#include "GuiTools.h"

MemPtr GetObjectPtr(UInt16 objectID)
{
    FormPtr frm = FrmGetActiveForm();
    return FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID));
}

MemPtr GetObjectPtrFromForm(FormPtr frm, UInt16 objectID)
{
    return FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID));
}

void SetFocus(UInt16 objectID)
{
    FormPtr frm = FrmGetActiveForm();
    FrmSetFocus(frm, FrmGetObjectIndex(frm, objectID));
}

void SetText(FieldPtr fieldPtr, const Char *text)
{
    MemHandle textH, oldH;
    if (!text) text = "";
    textH = MemHandleNew(StrLen(text)+1);
    if (!textH) return;
    StrCopy(MemHandleLock(textH), text);
    MemHandleUnlock(textH);
    oldH = FldGetTextHandle(fieldPtr);
    FldSetTextHandle(fieldPtr, textH);
    if (oldH) MemHandleFree(oldH);
}

void SetTextById(UInt16 fieldId, const Char *text)
{
    FieldPtr field = (FieldPtr)GetObjectPtr(fieldId);
    if (!field) return;
    SetText(field, text);
}

Char * GetText(FieldPtr fieldPtr)
{
    // Allocates new memory!
    //
    Char *textP, *result;
    MemHandle textH = FldGetTextHandle(fieldPtr);
    if (!textH) return NULL;
    textP = MemHandleLock(textH);
    result = (Char*)MemPtrNew(StrLen(textP)+1);
    StrCopy(result, textP);
    MemHandleUnlock(textH);
    return result;
}

Char * GetTextById(UInt16 fieldId)
{
    FieldPtr field = (FieldPtr)GetObjectPtr(fieldId);
    if (!field) return NULL;
    return GetText(field);
}

void PutNumInField(FieldPtr fieldPtr, Int32 val)
{
    Char str[16];
//    str = (CharPtr)MemPtrNew(16);
    StrIToA(str, val);
    SetText(fieldPtr, str);
//    MemPtrFree(str);
}
 
Int32 GetNumFromField(FieldPtr fieldPtr)
{
    // Returns -1 if field contains no text.
    //
    Int32 val;
    Char *str = GetText(fieldPtr);
    if (!str) return -1;
    if (!str[0]) { MemPtrFree(str); return -1; }
    val = StrAToI(str);
    MemPtrFree(str);
    return val;
}

