/**
 * Routines to make palmos FloatMgr work with gcc.
 * From: http://www.lispme.de/lispme/gcc/tech.html#fp
 * Also needs a NewFloatMgr.h that compiles with gcc.
 * From: http://www.40-below.com/palm/NewFloatMgr.h
 */
#include "floatmgr.h"

void SysTrapFlpLToF(FlpDouble* d, long l) SYS_TRAP(sysTrapFlpEmDispatch);

double longToDouble(long l)
{
  FlpCompDouble fcd;
  asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_itod) : "d2");
  SysTrapFlpLToF(&fcd.fd, l);
  return fcd.d;
}

long SysTrapFlpFToL(FlpDouble d) SYS_TRAP(sysTrapFlpEmDispatch);

long doubleToLong(double d)
{
  FlpCompDouble fcd;
  fcd.d = d;
  asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_dtoi) : "d2");
  return SysTrapFlpFToL(fcd.fd);
}

void SysTrapBinOp(FlpDouble* d, FlpDouble a, FlpDouble b) SYS_TRAP(sysTrapFlpEmDispatch);

/* the same interface is used for all basic arithmetic operations */
double genericDoubleOp(double a, double b, long opcode)
{
  FlpCompDouble fcda, fcdb, fcds;
  fcda.d = a; fcdb.d = b;
  asm("move.l %0,%%d2" : : "g" (opcode) : "d2");
  SysTrapBinOp(&fcds.fd, fcda.fd, fcdb.fd);
  return fcds.d;
}

